package org.example.wedding_app_backend.weddingGuest.entity;

import jakarta.persistence.*;
import lombok.*;
import org.example.wedding_app_backend.wedding.entity.WeddingEntity;
import org.example.wedding_app_backend.weddingImage.entity.WeddingImageEntity;

import java.util.List;
import java.util.UUID;

@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@ToString
@EqualsAndHashCode
@Entity
@Table(name = "wedding_guests")
public class WeddingGuestEntity {

    @Id
    private UUID id;

    private Integer questionIndex;

    private Integer quizPoints;

    private boolean quizFinished;

    private Integer quizSeed;

    private String guestName;

    private Integer whoKnowsQuestionIndex;

    private boolean whoKnowsQuizFinished;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "wedding")
    private WeddingEntity wedding;

    @ManyToMany(fetch = FetchType.LAZY)
    @JoinTable(
            name = "guest_liked_images",
            joinColumns = @JoinColumn(name = "guest_id"),
            inverseJoinColumns = @JoinColumn(name = "image_id")
    )
    private List<WeddingImageEntity> likedImages;

}
