package org.example.wedding_app_backend.weddingGuest.service;

import lombok.RequiredArgsConstructor;
import org.example.wedding_app_backend.wedding.repository.WeddingRepository;
import org.example.wedding_app_backend.weddingGuest.entity.WeddingGuestEntity;
import org.example.wedding_app_backend.weddingGuest.repository.WeddingGuestRepository;
import org.example.wedding_app_backend.weddingImage.entity.WeddingImageEntity;
import org.example.wedding_app_backend.weddingImage.repository.WeddingImageRepository;
import org.example.wedding_app_backend.weddingQuiz.entity.WeddingQuizEntity;
import org.example.wedding_app_backend.weddingQuiz.repository.WeddingQuizRepository;
import org.example.wedding_app_backend.whoKnowsBetterQuiz.model.WhoKnowsBetterQuiz;
import org.example.wedding_app_backend.whoKnowsBetterQuiz.repository.WhoKnowsBetterQuizRepository;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;
import java.util.UUID;

@Service
@RequiredArgsConstructor
public class WeddingGuestService {

    private final WeddingGuestRepository weddingGuestRepository;

    private final WeddingRepository weddingRepository;

    private final WeddingQuizRepository weddingQuizRepository;

    private final WhoKnowsBetterQuizRepository whoKnowsBetterQuizRepository;

    public void save(WeddingGuestEntity weddingGuest) {
        weddingGuestRepository.save(weddingGuest);
    }

    public Optional<WeddingGuestEntity> findWeddingGuestById(UUID weddingId, UUID guestId) {
        return weddingGuestRepository.findByWeddingIdAndId(weddingId, guestId);
    }

    public Optional<List<WeddingGuestEntity>> findAllByWeddingId(UUID weddingId) {
        return weddingGuestRepository.findAllByWeddingId(weddingId);
    }

    public Optional<WeddingGuestEntity> findWeddingGuest(UUID id) {
        return weddingGuestRepository.findById(id);
    }

    public Optional<List<WeddingGuestEntity>> findAllWeddingGuestsThatFinishedQuiz(UUID id){return weddingGuestRepository.findAllByWeddingIdAndQuizFinishedTrue(id);}

    public void updateQuizPoints(UUID WeddingGuestId, int score) {
        weddingGuestRepository.findById(WeddingGuestId).ifPresent(weddingGuest -> {
            weddingGuest.setQuizPoints(weddingGuest.getQuizPoints() + score);
            weddingGuestRepository.save(weddingGuest);
        });
    }

    public void updateQuizIndex(UUID WeddingGuestId, UUID WeddingId) {
        WeddingGuestEntity guest = weddingGuestRepository.findById(WeddingGuestId)
                .orElseThrow(() -> new NoSuchElementException("Guest with ID " + WeddingGuestId + " not found."));

        guest.setQuestionIndex(guest.getQuestionIndex() + 1);

        Optional<WeddingQuizEntity> question = weddingQuizRepository.findQuestionById(guest.getQuestionIndex(),WeddingId,guest.getQuizSeed());

        if(question.isEmpty()){
            guest.setQuizFinished(true);
        }
        weddingGuestRepository.save(guest);
    }
    public void updateWhoKnowsBetterQuizIndex(UUID WeddingGuestId, UUID WeddingId) {

        WeddingGuestEntity guest = weddingGuestRepository.findById(WeddingGuestId)
                .orElseThrow(() -> new NoSuchElementException("Guest with ID " + WeddingGuestId + " not found."));

        guest.setWhoKnowsQuestionIndex(guest.getWhoKnowsQuestionIndex() + 1);

        Optional<WhoKnowsBetterQuiz> nextQuestion = whoKnowsBetterQuizRepository.findByWeddingIdAndQuestionIndex(WeddingId, guest.getWhoKnowsQuestionIndex());

        if(nextQuestion.isEmpty()){
            guest.setWhoKnowsQuizFinished(true);
        }

        weddingGuestRepository.save(guest);
    }
}
