package org.example.wedding_app_backend.weddingImage.function;

import org.example.wedding_app_backend.wedding.entity.WeddingEntity;
import org.example.wedding_app_backend.weddingImage.entity.WeddingImageEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.UUID;
import java.util.function.BiFunction;

@Component
public class RequestToWeddingImageFunction implements BiFunction<UUID, MultipartFile, WeddingImageEntity> {

    @Override
    public WeddingImageEntity apply(UUID weddingId, MultipartFile file) {
        try {
            return WeddingImageEntity.builder()
                    .id(UUID.randomUUID())
                    .likes(0)
                    .date(LocalDateTime.now())
                    .wedding(WeddingEntity.builder()
                            .id(weddingId)
                            .build())
                    .image(file.getInputStream().readAllBytes())
                    .build();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
