import {RouterModule, Routes} from '@angular/router';
import {NgModule} from '@angular/core';
import {authGuard} from './guards/auth.guard';

export const routes: Routes = [
  // na razie wsszystko routuje do strony wedding ale pozniej bedzie home dla domyslnej
  {
    path: 'wedding/:weddingId/:guestId',
    loadComponent: () => import('./components/wedding/wedding.component').then(m => m.WeddingComponent),
  },
  {
    path: 'wedding/:weddingId/:guestId/gallery',
    loadComponent: () => import('./components/gallery/gallery.component').then(m => m.GalleryComponent),
    canActivate: [authGuard], // Guard dla testów
  },
  {
    path: 'wedding/:weddingId/:guestId/games',
    loadComponent: () => import('./components/games-list/games-list.component').then(m => m.GamesListComponent),
  },
  {
    path: 'wedding/:weddingId/:guestId/games/quiz',
    loadComponent: () => import('./components/quiz/quiz.component').then(m => m.QuizComponent),
  },
  {
    path: 'wedding/:weddingId/:guestId/games/hall',
    loadComponent: () => import('./components/hall-of-fame/hall-of-fame.component').then(m => m.HallOfFameComponent),
  },
  {
    path: 'wedding/:weddingId/:guestId/games/who-knows-better',
    loadComponent: () => import('./components/who-knows-better-quiz/who-knows-better-quiz.component').then(m => m.WhoKnowsBetterQuizComponent),
  },
  {
    path: 'wedding/:weddingId/:guestId/games/who-knows-better/results',
    loadComponent: () => import('./components/who-knows-better-summary/who-knows-better-summary.component').then(m => m.WhoKnowsBetterSummaryComponent),
  },
  // Obsługa nieznanych tras (404)
  {
    path: '**',
    redirectTo: 'home',
  }
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule],
})
export class AppRoutingModule {}


