// keycloak.interceptor.ts
import { KeycloakService } from 'keycloak-angular';
import { HttpInterceptorFn } from '@angular/common/http';
import {inject} from '@angular/core';

export const keycloakInterceptor: HttpInterceptorFn = (req, next) => {  const keycloak = inject(KeycloakService);
  if (keycloak.isLoggedIn()) {
    const token = keycloak.getKeycloakInstance().token;

    if (token) {
      req = req.clone({
        setHeaders: {
          Authorization: `Bearer ${token}`
        }
      });
    }
  }

  return next(req);
};
