import { KeycloakService } from 'keycloak-angular';
import { PLATFORM_ID, inject } from '@angular/core';
import { isPlatformBrowser } from '@angular/common';

export function initializeKeycloak() {
  const platformId = inject(PLATFORM_ID);
  const keycloak = inject(KeycloakService);

  return () => {
    if (isPlatformBrowser(platformId)) {
      return keycloak.init({
        config: {
          url: 'http://localhost:9090',
          realm: 'wedding-app-realm',
          clientId: 'bsn'
        },
        initOptions: {
          onLoad: 'login-required',
          flow: 'standard',
          checkLoginIframe: false
        },
        enableBearerInterceptor: false, // Wyłącz wbudowany interceptor
        bearerExcludedUrls: []
      });
    }
    return Promise.resolve();
  };
}

